// -*- C++ -*-
/*!
 * @file  Input.cpp
 * @brief InputComponent
 * @date $Date$
 *
 * $Id$
 */

#include "Input.h"

// Module specification
// <rtc-template block="module_spec">
static const char* input_spec[] =
  {
    "implementation_id", "Input",
    "type_name",         "Input",
    "description",       "InputComponent",
    "version",           "1.0.0",
    "vendor",            "Toshihiro.MIURA_ShibauraHRI",
    "category",          "TestComp",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

Input::Input(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_LEDOut("LED", m_LED),
    m_ADCOut("ADC", m_ADC),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("LED", m_LEDOut);
  registerOutPort("ADC", m_ADCOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

Input::~Input()
{
}

RTC::ReturnCode_t Input::onInitialize()
{
	std::cout << "--------------------------------------------------" << std::endl;
	std::cout << " Module Name: InputComponent" << std::endl;
	std::cout << " Vendor  : Toshihiro MIURA" << std::endl;
	std::cout << "           SIT Mizukawa Lab." << std::endl;
	std::cout << "--------------------------------------------------" << std::endl;
	return RTC::RTC_OK;
}

RTC::ReturnCode_t Input::onExecute(RTC::UniqueId ec_id)
{
	int iData;
	std::cout << "LED(8Bit,Dec) = ";
	std::cin >> iData;
	m_LED.data = (BYTE)iData;
	m_LEDOut.write();

	std::cout << "A/D(16bit,Dec) = ";
	std::cin >> m_ADC.data;
	m_ADCOut.write();
	return RTC::RTC_OK;
}



extern "C"
{

  void InputInit(RTC::Manager* manager)
  {
    RTC::Properties profile(input_spec);
    manager->registerFactory(profile,
                             RTC::Create<Input>,
                             RTC::Delete<Input>);
  }
  
};


