// -*- C++ -*-
/*!
 * @file  SendMessageTest.cpp
 * @brief SendMessageTestComponent
 * @date $Date$
 *
 * $Id$
 */

#include "SendMessageTest.h"

// Module specification
// <rtc-template block="module_spec">
static const char* sendmessagetest_spec[] =
  {
    "implementation_id", "SendMessageTest",
    "type_name",         "SendMessageTest",
    "description",       "SendMessageTestComponent",
    "version",           "1.0.0",
    "vendor",            "ToshihiroMiura_ShibauraHRI",
    "category",          "TestComp",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

SendMessageTest::SendMessageTest(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_TxMessageOut("TxMessage", m_TxMessage),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("TxMessage", m_TxMessageOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}


SendMessageTest::~SendMessageTest()
{
}


TimedOctetSeq SendMessageTest::ComposeTxMessage(CANTxMessageFrame CANTxMessage)
{
	TimedOctetSeq TxMessage;
	int i;
	TxMessage.data.length(CANTxMessage.DLC + 5);
	for(i= 0; i < 4; i++)
	{
		TxMessage.data[i] = (BYTE)CANTxMessage.ID;
		CANTxMessage.ID = CANTxMessage.ID >> 8;
	}
	TxMessage.data[i] = CANTxMessage.DLC;
	for(i++; i < CANTxMessage.DLC + 5; i++)
		TxMessage.data[i] = CANTxMessage.Data[i - 5].ByteAccess;
	return TxMessage;
}


RTC::ReturnCode_t SendMessageTest::onInitialize()
{
	std::cout << "--------------------------------------------------" << std::endl;
	std::cout << " Module Name: SendMessageTestComponent" << std::endl;
	std::cout << " Vendor  : Toshihiro MIURA" << std::endl;
	std::cout << "           SIT Mizukawa Lab." << std::endl;
	std::cout << "--------------------------------------------------" << std::endl;
	return RTC::RTC_OK;
}


RTC::ReturnCode_t SendMessageTest::onExecute(RTC::UniqueId ec_id)
{
	unsigned long ulID;
	int iDLC, iData;
	CANTxMessageFrame CANTxMessageTmp;
	memset(&CANTxMessageTmp, 0, sizeof(CANTxMessageTmp));
	std::cout << "ID = ";
	std::cin >> ulID;
	CANTxMessageTmp.ID = ulID;
	std::cout << "DLC = ";
	std::cin >> iDLC;
	CANTxMessageTmp.DLC = (BYTE)iDLC;
	m_TxMessage.data.length(CANTxMessageTmp.DLC + 5);
	for (int i = 0; i < CANTxMessageTmp.DLC; i++)
	{
		std::cout << "Data[" << i << "] = ";
		std::cin >> iData;
		CANTxMessageTmp.Data[i].ByteAccess = (BYTE)iData;
	}
	m_TxMessage = ComposeTxMessage(CANTxMessageTmp);
	m_TxMessageOut.write();
	return RTC::RTC_OK;
}


extern "C"
{
  void SendMessageTestInit(RTC::Manager* manager)
  {
    RTC::Properties profile(sendmessagetest_spec);
    manager->registerFactory(profile,
                             RTC::Create<SendMessageTest>,
                             RTC::Delete<SendMessageTest>);
  }  
};
